#include "CRM32Pro.h"

// ---Definiciones---
#define TUTORIAL_VERSION "Prueba de lineas" //titulo de la ventana
#define IMG_RESOURCE "imagenes.dpf" //paquete de imagenes


CRM32Pro_CFont *font;
char text[30];
Uint32 deltax=0,deltay=0;
int x1=320,y1=240;
int x2=210,y2=221;
int x=0,y=0;
int xinc1=0,xinc2=0;
int yinc1=0,yinc2=0;
Uint32 den=0,num=0,numadd=0,numpixels=0;
Uint32 curpixel=0;


void linea(int x1,int y1,int x2,int y2){
  deltax=abs(x2-x1);  //The difference between the xs
  deltay=abs(y2-y1);  //The difference between the ys
  x=x1;               //Start x off at the first pixel
  y=y1;               //Start y off at the first pixel

  if(x2>=x1){         //The x-value are increasing
    xinc1=1;
    xinc2=-1;
  }else{              //The x-values are decreasing
    xinc1=-1;
    xinc2=1;
  }

  if(y2>=y1){         //The y-values are increasing
    yinc1=1;
    yinc2=1;
  }else{              //The y-values are decreasing
    yinc1=-1;
    yinc2=-1;
  }

  if(deltax>=deltay){ //There is at least one x-value for everly y-value
      xinc1=0;          //Dont change the x when numerator>=denominator
      yinc2=0;          //Dont change the y when numerator>=denominator
      den=deltax;
      num=deltax/2;
      numadd=deltay;
      numpixels=deltax; //There are more x-values than y-values
  }else{              //There is at least one y-value for every x-value
    xinc2=0;          //Dont change the x for every interation
    yinc1=0;          //Dont change the y when numerator>=denomiator
    den=deltay;
    num=deltay/2;
    numadd=deltax;
    numpixels=deltay; //There are more y-values then x-values
  }

  for(curpixel=0;curpixel<=numpixels;curpixel++){
    IPrimitives->PutPixel(CRM32Pro.screen,x,y,16777215);    //Draw the current pixel
    num+=numadd;      //Increase the numerator by the top of the fraction
    if(num>=den){     //Check if numerator>=denominator
      num-=den;       //Calculate the new numerator value
      x+=xinc1;       //Change the x as appropiate
      y+=yinc1;       //Change the y as appropiate
    }
    x-=xinc2;         //Change the x as appropiate
    y+=yinc2;         //Change the y as appropiate
  }
}

void RenderGraphics(int n){
  Uint8 *keys;

  SDL_FillRect(CRM32Pro.screen,NULL,SDL_MapRGB(CRM32Pro.screen->format,0,0,0));

  sprintf(text,"X1=%d Y1=%d",x1,y1);
  font->PutString(CRM32Pro.screen,5,5,text);
  sprintf(text,"X2=%d Y2=%d",x2,y2);
  font->PutString(CRM32Pro.screen,5,20,text);
  sprintf(text,"deltax=%d deltay=%d",x2-x1,y2-y1);
  font->PutString(CRM32Pro.screen,5,35,text);
  sprintf(text,"ABS(deltax)=%d ABS(deltay)=%d",abs(x2-x1),abs(y2-y1));
  font->PutString(CRM32Pro.screen,5,50,text);

  keys=SDL_GetKeyState(NULL);
  //Controles del punto 1
  if(keys[SDLK_w]){
    y1--;
  }
  if(keys[SDLK_s]){
    y1++;
  }
  if(keys[SDLK_a]){
    x1--;
  }
  if(keys[SDLK_d]){
    x1++;
  }

  //Controles del punto 2
  if(keys[SDLK_UP]){
    y2--;
  }
  if(keys[SDLK_DOWN]){
    y2++;
  }
  if(keys[SDLK_LEFT]){
    x2--;
  }
  if(keys[SDLK_RIGHT]){
    x2++;
  }

  if(x1<0)x1=0;
  if(x2<0)x2=0;
  if(x1>=639)x1=638;
  if(x2>=639)x2=638;
  if(y1<0)y1=0;
  if(y2<0)y2=0;
  if(y1>=479)y1=478;
  if(y2>=479)y2=478;

  //Cruzeta punto 1 en amarillo
  IPrimitives->PutPixel(CRM32Pro.screen,x1,y1,16776960);  //Amarillo punto1
  IPrimitives->PutPixel(CRM32Pro.screen,x1-1,y1,16776960);
  IPrimitives->PutPixel(CRM32Pro.screen,x1+1,y1,16776960);
  IPrimitives->PutPixel(CRM32Pro.screen,x1,y1+1,16776960);
  IPrimitives->PutPixel(CRM32Pro.screen,x1,y1-1,16776960);
  //Cruzeta punto 2 en verde
  IPrimitives->PutPixel(CRM32Pro.screen,x2,y2,65280);     //Verde punto2
  IPrimitives->PutPixel(CRM32Pro.screen,x2-1,y2,65280);
  IPrimitives->PutPixel(CRM32Pro.screen,x2+1,y2,65280);
  IPrimitives->PutPixel(CRM32Pro.screen,x2,y2+1,65280);
  IPrimitives->PutPixel(CRM32Pro.screen,x2,y2-1,65280);

  linea(x1,y1,x2,y2);

}
// -------------FUNCION MAIN----------------
int main( int argc, char* args[] )
{
    // ---Variables---
    Uint8 done = 0;
    //SDL_Rect dest;
    SDL_Event event;            //para recoger los eventos
    //SDL_Surface *logo = NULL;   //Las superficies que utilizaremos
    //SDL_Surface *background = NULL;
    //Iniciamos CRM32Pro
    if(CRM32Pro.Init(SDL_INIT_VIDEO) < 0)
    {
        printf("No se ha podido iniciar CRM32Pro: %s\n",SDL_GetError());
        return 1;
    }

    //Configuracion deseada
    CRM32Pro.Config.Title = TUTORIAL_VERSION; //titulo de la ventana
    CRM32Pro.Config.VideoWidth = 640;   //establecemos la resolucion: 640 de ancho
    CRM32Pro.Config.VideoHeight = 480;  //por 480 de alto
    CRM32Pro.Config.VideoBPP = 32;      //y una profunidad de bit de 32

    //Establecemos el modo de video
    if(!CRM32Pro.SetVideoMode())
    {
        CRM32Pro.Quit();
        return 1;
    }

  // -Time system initialize-
  ITimeSystem->Init();
  ITimeSystem->SetRate(40,20);  // Optional: desired Rendering and Logic Frame Rate

    //Cargamos los graficos
  font = new CRM32Pro_CFont;
  font->Load(IMG_RESOURCE,"fuente");

  CRM32Pro.SetRenderCallback(RenderGraphics);


    // Mostramos la pantalla
    SDL_Flip(CRM32Pro.screen);

    // Esperamos la pulsacin de una tecla para salir
    while(done == 0) {
        while ( CRM32Pro.Update(&event) ) {
      if ( event.type == SDL_KEYDOWN )
        if(event.key.keysym.sym == SDLK_ESCAPE)
          done = 1;
    }
    }

    //Liberamos las superficies
    //CRM32Pro.FreeSurface(background);
    //CRM32Pro.FreeSurface(logo);

    //Quit CRM32Pro
    CRM32Pro.Quit();

    return 0;
}

